# Android源码设计模式分析开源项目

## 简述
设计模式已经成为开发人员最重要的技能之一，它们能够让你优雅、简单、灵活地解决开发中遇到的设计难题，让你的软件系统具有更好的可扩展性、灵活性，在特定场景之下让你的软件系统实现拥抱变化。但设计模式运用在Android上的书籍并不多，Android本身又是开源，那么剖析Android源码中的设计模式必定是我们学习设计模式的一个非常好的渠道。我们在大型系统中学习设计模式的运用，领悟它的设计思考、灵活运用，既学到了设计模式本身，也深入Android源码了解了它的一些核心原理。      
 
## 一期成果 ( 2015.03.21 )
|     模式名    |    作者    |
|    -----    |    ------   |
|    [单例模式](singleton/mr.simple)   	 | [Mr.Simple](https://github.com/bboyfeiyu)|  
|    [Builder模式](builder/mr.simple)  	 | [Mr.Simple](https://github.com/bboyfeiyu)|  
|    [外观模式](facade/elsdnwn)   	     | [elsdnwn](https://github.com/elsdnwn)、[Mr.Simple](https://github.com/bboyfeiyu)|   
|    [模板方法](template-method/mr.simple)   | [Mr.Simple](https://github.com/bboyfeiyu) | 
|    [适配器模式](adapter/mr.simple)    | [Mr.Simple](https://github.com/bboyfeiyu) | 
|    [观察者模式](observer/mr.simple)    | [Mr.Simple](https://github.com/bboyfeiyu) |  
|    [策略模式](strategy/gkerison)      | [GKerison](https://github.com/GKerison) | 
|    [代理模式](proxy/singwhatiwanna)   | [singwhatiwanna](https://github.com/singwhatiwanna) |  
|    [迭代器模式](iterator/haoxiqiang) | [Haoxiqiang](https://github.com/Haoxiqiang)|  
|    [责任链模式](chain-of-responsibility/AigeStudio) | [AigeStudio](https://github.com/AigeStudio)|  
|    [命令模式](command/lijunhuayc) | [lijunhuayc](https://github.com/lijunhuayc)|  
|    [桥接模式](bridge/shen0834) | [shen0834](https://github.com/shen0834)|  
|    [原型模式](prototype/mr.simple) | [Mr.Simple](https://github.com/bboyfeiyu)| 

非常感谢做出分享的同学， 此处应该有掌声!!!      


另外，该系列文章我们会根据技术发展、实战需求以及读者您的反馈重写所有章节，并且加入更加深入的核心机制分析以及模式在Android开发中的实战，完善后的文稿将会编撰成书出版，以便帮助大家更系统的学习，此时更真心地希望大家能够给出完善建议，以便本书更贴近您的需求，联系邮箱为 : simplecoder.h@gmail.com，谢谢。

## 更多模式
[Android源码设计模式分析开源项目-开发分支](https://github.com/simple-android-framework-exchange/android_design_patterns_analysis)。

## 参考资料
* [GOF的设计模式：可复用面向对象软件的基础](http://pan.baidu.com/s/1i3zjaIx)
* [设计模式之禅](http://pan.baidu.com/s/1sjjZCvj)
* [Java与模式](http://pan.baidu.com/s/1i3sxzyH)
* [java-design-patterns](https://github.com/iluwatar/java-design-patterns)
* [Java之美[从菜鸟到高手演变]之设计模式](http://blog.csdn.net/zhangerqing/article/details/8194653)
